local lua_ref = gui.Reference("Visuals", "World","Extra")
local lua_enable_hitmarker = gui.Checkbox(lua_ref, "enable_hitmarker", "Enable Round Hitmarker Indicators", true)  
local lua_hitmarker_enable_outline = gui.Checkbox(lua_ref, "hitmarker_enable_outline", "Enable Outline to Circle", false)
local lua_hitmarker_color = gui.ColorPicker(lua_ref, "hitmarker_color", "Hitmarker Color", 255, 255, 255, 230)
local lua_hitmarker_time =  gui.Slider(lua_ref, "hitmarker_time", "Hitmarker Time of Visibility", 150, 50, 800, 10)

local particles = {{}}
local shot_particle = {}
function Enemy_Hurted(GameEvent)
if not entities:GetLocalPlayer() or not entities:GetLocalPlayer():IsAlive() then 
        return
    end
if not lua_enable_hitmarker then
lua_hitmarker_enable_outline:SetInvisible(true)
lua_hitmarker_color:SetInvisible(true)
lua_hitmarker_time:SetInvisible(true)
else
lua_hitmarker_enable_outline:SetInvisible(false)
lua_hitmarker_color:SetInvisible(false)
lua_hitmarker_time:SetInvisible(false)
end

    local math_random_1 = math.random(1,10)
    local math_random_2 = math.random(1,10)
    local math_random_3 = math.random(1,10)
    if GameEvent then
        if GameEvent:GetName() == "player_hurt" then
            local user_id = GameEvent:GetInt("userid")
            local user = entities.GetByUserID(user_id)
            local user_index = entities.GetByUserID(user_id):GetIndex()
            local attacker_id = GameEvent:GetInt("attacker")
            local attacker = entities.GetByUserID(attacker_id)
            local attacker_index = entities.GetByUserID(attacker_id):GetIndex()
            local localplayer_index = entities:GetLocalPlayer():GetIndex()
            if attacker_index == localplayer_index and user_index ~=localplayer_index then
                local HitGround = GameEvent:GetInt("hitgroup")
                pos_hitmarker = user:GetHitboxPosition(  GameEvent:GetInt("hitgroup") )
                if pos_hitmarker == nil then
                    pos_hitmarker = entities.GetAbsOrigin(user)
                    pos_hitmarker.z  = pos_hitmarker.z + 30 
                end

                shot_particle = {}

                table.insert(shot_particle, pos_hitmarker.x)
                table.insert(shot_particle, pos_hitmarker.y)
                table.insert(shot_particle, pos_hitmarker.z)

                time_hitmarker = globals.TickCount()+ lua_hitmarker_time:GetValue()
                table.insert(shot_particle, time_hitmarker)

                table.insert(particles, shot_particle)
            end
        end
    end
end
client.AllowListener("player_hurt");
callbacks.Register("FireGameEvent", Enemy_Hurted);
callbacks.Register("Draw", Enemy_Hurted);

function render_hitmarker()
if not entities:GetLocalPlayer() or not entities:GetLocalPlayer():IsAlive() then 
        particles = {}
        timer_hitmarker = 0
    end
    for i = 1, #particles, 1 do
        if particles[i][1] ~= nil and  particles[i][2] ~= nil and particles[i][3] ~= nil then
            position_hitmarker_x, pos_hitmarker_y = client.WorldToScreen(Vector3(particles[i][1], particles[i][2], particles[i][3]))
            local timer_hitmarker = particles[i][4]  - globals.TickCount()
            if timer_hitmarker > 255 then
                timer_hitmarker = 255
            end
            local hitmarker_color_r, hitmarker_color_g, hitmarker_color_b, hitmarker_color_a = lua_hitmarker_color:GetValue()
            if timer_hitmarker > 0 then
                if lua_enable_hitmarker:GetValue() and position_hitmarker_x ~= nil and pos_hitmarker_y ~= nil then
                    draw.Color( hitmarker_color_r, hitmarker_color_g, hitmarker_color_b, timer_hitmarker)
                    draw.FilledCircle(position_hitmarker_x, pos_hitmarker_y, 15 - ((timer_hitmarker/100)*5))
                    if lua_hitmarker_enable_outline:GetValue() then
                        draw.Color(hitmarker_color_r, hitmarker_color_g, hitmarker_color_b,hitmarker_color_a - math.floor(((255-timer_hitmarker)/1.15)))
                        draw.OutlinedCircle(position_hitmarker_x, pos_hitmarker_y, 15 - ((timer_hitmarker/100)*5))
                    end
                end
            end
        end
    end
end
callbacks.Register('Draw', render_hitmarker)